/*

FREEDOS.H - Free-DOS header file
Written by: James Hall, modified by Morgan Toal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Change Log:	JH 10/94	Original Source
		MT 4/95		Added peeks for screen size

*/

#ifdef _MICROC_
extern int _AX_, _BX_, _CX_, _DX_;
#endif

/* the version of the Free-DOS release */
#define VER_REL      "Alpha 4"

/* the maximum string length */
#define MAX_STR 256

/* values for true and false */
#define TRUE 1
#define FALSE 0

#define UNIX_NL '\012'
#define MAC_NL  '\013'
#define DOS_NL  '\n'
#define ARGCHAR '='
#define SWCHAR '/'

/* some macros for printing the usage */
#define printp(A,B) fprintf(stderr, "\n%s: %s\n", A, B)
#define printc(A,B) fprintf (stderr, "(C) %s %s - Free-DOS %s release\n\n", A, B, VER_REL)
#define printu(A,B) fprintf(stderr, "Usage: %s %s\n\n", A, B)
#define printo(A,B) fprintf(stderr, "  /%s - %s\n", A, B)

/* messages for PAGEF.C */

#define PAGEF_PR     "(more)"
#define PAGEF_END    "(end)"

/* messages for HELP.C */
#define MSG_NOHELP  "Sorry, no help found on topic \"%s\".\n"
#define MSG_TOPICS  "Help is available on the following topics:\n"
#define MSG_NOTOPICS "Sorry, no help found on any topics.\n"

