/*
    utility for the message handling library
    Copyright (C) 1995  Steffen Kaiser

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   
*/
/* $RCSfile: MSGLIB.C $
   $Locker: ska $	$Name:  $	$State: Rel $

	Generate linker a response file from a file list.

	Usage: msgMake [{file}...] >responseFile

	If file is omitted, stdin is read.
	The file is a whitespace delimited list of object files,
	msgLib creates a librarian response file.

	There will be no error reporting at all.

   $Log: MSGLIB.C $
   Revision 1.2  1995/04/21 04:35:09  ska
   version 1.0

   Revision 1.1  1995/04/21 00:57:00  ska
   Initial revision
   Supported compilers:
   	+ Micro-C updated v3.13
   	+ Borland C v3.0+ (maybe earlier)

*/

#include <stdio.h>
#ifndef _MICROC_
#include <string.h>
#endif
#include <freedos.h>

#ifndef lint
static char const rcsid[] = 
	"$Id: MSGLIB.C 1.2 1995/04/21 04:35:09 ska Rel ska $";
#endif

#define BUF 4096
char buf[BUF];
char o[BUF] = "";

void handle(FILE *fin)
{	char *s;

	while(fgets(buf, BUF, fin))
		if(s = strtok(buf, " \t\n")) do {
			if(*s) {
				stpcpy(stpcat(o, "+ "), s);
				fputs(o, stdout);	/* NO \n !!! */
				stpcpy(o, " &\n");
			}
		} while(s = strtok(NULL, " \t\n"));
}

int main(int argc, char **argv)
{	FILE *fp;

	if(argc == 1)	/* clean up from stdin */
		handle(stdin);
	else while(*++argv)
		if(fp = fopen(*argv, "rt")) {
			handle(fp);
			fclose(fp);
		}

	putchar('\n');
#ifndef _MICROC_
	return 0;
#endif
}

