/* $Id$
   $Locker$	$Name$	$State$

	Declaration of functions and global variables within the
	FreeDos library.

   $Log$
*/

#ifndef __FDLIB_H
#define __FDLIB_H

int strtod(char *nr, char **endp, int radix);
#define strtol strtod
/* Convert a string into an int value.

   Arguments:
   	nr: ASCII string: [{ws}][-|+][{ws}]{digit}[{ws}]
   		ws: whitespace, as stated by isspace()
   		digit: 0..9, a..z or A..Z; where a == A == 10
   	endp: pointer behind the third {ws}
   	radix: base of the number; if zero, radix is computed
		fromout the start of {digit} as in C sources:
			1) first digit == 0 && second digit == x or X => radix = 16
			2) first digit == 0 => radix = 8
			3) => radix = 10

   Return:
   	return value: as computed until end or error; if not digit at all, zero
   	endp: points to the character, where the error occured
   	      NULL, if the whole string was read
   	      if endp is NULL, no error position is stored
*/
#endif
