/*
    SWSUBST: Alternate CDS manipulator for MS-DOS
    Copyright (C) 1995 Steffen Kaiser

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/


/* $RCSfile: swap.c $
   $Locker: ska $	$Name: version2 $	$State: Rel $

	Swap the CDS entries of two drives.

   $Log: swap.c $
   Revision 1.2  1995/05/24 09:31:11  ska
   add: support for message compiler.

   Revision 1.1  1995/03/09 07:10:13  ska
   Initial revision

*/
#pragma hdrfile "simple.csm"

#include <string.h>

#include "swsubst.h"
#include "error.h"

#ifndef lint
static char rcsid[] = "$Id: swap.c 1.2 1995/05/24 09:31:11 ska Rel ska $";
#endif

void swap(char *d1, char *d2)
{	/* swap drive ntries d1 and d2 */
	char dr1, dr2;

	if((dr1 = Drive(&d1)) != NoDrive && (dr2 = Drive(&d2)) != NoDrive) {
		CDS FAR *dir1, FAR *dir2, dir;

		if((dir1 = cds(dr1)) != NULL && (dir2 = cds(dr2)) != NULL) {
			_fmemcpy(&dir, dir1, sizeof(dir));
			_fmemcpy(dir1, dir2, sizeof(dir));
			_fmemcpy(dir2, &dir, sizeof(dir));
			if((dir1->flags & (NETWORK | HIDDEN)) == 0)
				dir1->u.LOCAL.start_cluster = 0xffff;
			if((dir2->flags & (NETWORK | HIDDEN)) == 0)
				dir2->u.LOCAL.start_cluster = 0xffff;
			return;	/* OK */
		}
	}
	error(E_swap, d1, d2);
}

